--[[ 
	Title: Sandbox

	This is random code that is not ready to see the light of day yet.
]]
module( "ULib3", package.seeall )

if SANDBOX_LUA then return end
SANDBOX_LUA = true

include( 'log4lua.lua' )









BaseArg = inherits_from( nil )

function BaseArg:validate()
	return true -- Allow anything
end

function BaseArg:instantiate( init_values ) -- We'll be using this a lot so implement in base
	if not type( init_values ) == "table" then
		print( "Incorrectly instantiated BaseArg" )
	end

	for k, v in pairs( init_values ) do
		self[ k ] = v
	end
end


IntArg = inherits_from( BaseArg )

function IntArg:validate()
	for i, v in ipairs( self ) do
		if type( v ) ~= "number" or math.floor( v ) ~= v then
			print( "Param not a num" )
			return false
		end
		
		if (self.max and v > self.max) or (self.min and v < self.min) then
			print( "Exceeds bounds" )
			return false
		end
	end
	
	return true
end

function validate_args( ... )	
	for i, v in ipairs( arg ) do
		if not isClass( v ) or not v:isa( BaseArg ) then
			print( "Invalid arg" )
			return false
		end
		
		if not v:validate() then
			return false
		end
	end
	
	return true
end

-- Test func
function printi( i )
	if not validate_args( IntArg{ i, max=10, min=0 } ) then
		print( "failure", i )
		return
	end
	
	print( "success", i )
end

--[[printi( true )
printi( 2.2 )
printi( -1 )
printi( 11 )
printi( 5 )]]


--[[
	Function: parseKeyValues

	Parses a keyvalue formatted string into a table.

	Parameters:

		str - The string to parse.
		convert - *(Optional, defaults to false)* Setting this to true will convert garry's keyvalues to a better form. This has two effects.
		  First, it will remove the "Out"{} wrapper. Second, it will convert any keys that equate to a number to a number.

	Returns:

		The table, nil and error otherwise. *If you find you're missing information from the table, the file format might be incorrect.*

	Example input format:
:test
:{
:	"howdy"   "bbq"
:	"order"
:	"preserved"
:
:	foo
:	{
:		"bar"   "false"
:	}
:
:}

	Example output format:
:{
:	['test'] = {
:		"order",
:		"preserved",
:		["howdy"] = "bbq",
:		["foo"] = {
:			["bar"] = "false",
:		},
:	},
:}

	Revisions:

		v3.00 - Re-write
]]
function parseKeyValues( str, convert )
	str = ULib.stripComments( str, "//" )
	local lines = string.Explode( "\n", str )
	local data = {} -- Our running total of data collected
	local line_num = 1
	
	while lines[ line_num ] do
		local line = lines[ line_num ]
		local words = ULib.splitArgs( string.Trim( line ) )
		local num_words = #words
		if num_words > 2 then
			return nil, "Invalid data (too many words) on line " .. line_num
		end
		
		if words[ 1 ] == "{" or (num_words == 1 and lines[ line_num + 1 ] and string.Trim( lines[ line_num + 1 ] ) == "{") then
			if num_words == 1 and lines[ line_num + 1 ] and string.Trim( lines[ line_num + 1 ] ) == "{" then
				line_num = line_num + 1
				num_words = 2
			end
			
			local inline_level = 1
			local preview_line_num = line_num
			while inline_level > 0 do
				preview_line_num = preview_line_num + 1
				if not lines[ preview_line_num ] then
					return nil, "Mismatched brace on line " .. line_num
				end
			
				local preview_line = string.Trim( lines[ preview_line_num ] )
				if preview_line == "}" then
					inline_level = inline_level - 1
				elseif preview_line == "{" then
					inline_level = inline_level + 1
				end
			end
			
			local substr = table.concat( lines, "\n", line_num + 1, preview_line_num - 1 )
			local new_table, err = parse_key_values( substr )
			
			if not new_table then return nil, err end
			words[ num_words ] = new_table
			line_num = preview_line_num + 1
		end
		
		if num_words == 1 then
			table.insert( data, words[ 1 ] )
		elseif num_words == 2 then
			data[ words[ 1 ] ] = words[ 2 ]
		end
		line_num = line_num + 1
	end
	
	return data, "Success"
end
--local t, msg = parse_key_values( file.Read( "test.txt" ) )
--print( msg )
--PrintTable( t )