function ULib.registerClGlobal( _global, metatable_cache, makepairs ) -- We wrap this file in a function so we can receive and manipulate the "real" table.

ULib.global = ULib.makeReadOnly( _global ) -- Make the global server table read only for them.


local function rcvUpdate( um )
	local loc = ULib.umsgRcv( um )
	local key = ULib.umsgRcv( um )
	local value = ULib.umsgRcv( um )

	if not loc or key == nil then
		ULib.error( "Bad data in rcvUpdate!" )
		return
	end
	
	local curT = _global.server

	for _, v in ipairs( loc ) do
		curT = curT[ v ]
		if not curT then
			ULib.error( "Invalid table sent via rcvUpdate!" )
			return
		end
	end

	curT[ key ] = value
end
usermessage.Hook( "ULib_global_server", rcvUpdate )
	

end