function ULib.execFile( f, ply )
	if not file.Exists( f ) then
		ULib.error( "Called execFile with invalid file! " .. file )
		return
	end

	local f = ULib.stripComments( file.Read( f ), "//" )
	local lines = string.Explode( "\n", f )

	for _, line in ipairs( lines ) do
		line = string.Trim( line )
		if line ~= "" then
			if SERVER then
				if not ply then
					game.ConsoleCommand( line .. "\n" )
				else
					ply:ConCommand( line .. "\n" )
				end
			else
				LocalPlayer():ConCommand( line .. "\n" )
			end
		end
	end
end